using System.Text.Json.Serialization;
using Foxcord.Gateway.Events.Commands;

namespace Foxcord.Gateway.Events;

public class IdentifyEvent : IGatewayEvent
{
    public required string Token { get; init; }
    public IdentifyProperties Properties { get; init; } = new();
    public GatewayIntent Intents { get; init; }
    public PresenceUpdateCommand.PresenceUpdatePayload? Presence { get; init; }

    [JsonIgnore(Condition = JsonIgnoreCondition.WhenWritingNull)]
    public int[]? Shards { get; init; }
}

public class IdentifyProperties
{
    public string Os { get; init; } = "Linux";
    public string Browser { get; init; } = "Foxcord";
    public string Device { get; init; } = "Foxcord";
}