namespace Foxcord.Models;

public record Activity(
    string Name,
    ActivityType Type,
    string? Url = null,
    DateTimeOffset CreatedAt = default,
    ActivityTimestamps? Timestamps = null,
    ActivityEmoji? Emoji = null,
    string? State = null);

public record ActivityTimestamps(int? Start = null, int? End = null);

public record ActivityEmoji(string Name, Snowflake? Id = null, bool? Animated = null);

public enum ActivityType
{
    Playing = 0,
    Streaming = 1,
    Listening = 2,
    Watching = 3,
    Custom = 4,
    Competing = 5,
}