using System.Text.Json.Serialization;

namespace Foxcord.Models;

public record User
{
    public Snowflake Id { get; init; }
    public required string Username { get; init; }
    public required string Discriminator { get; init; }
    [JsonIgnore] public string Tag => Discriminator != "0" ? $"{Username}#{Discriminator}" : Username;
    public string? GlobalName { get; init; }
    public string? Avatar { get; init; }
    public string? Banner { get; init; }
    public int? AccentColor { get; init; }
    public string? Locale { get; init; }
    public bool Bot { get; init; } = false;
    public bool System { get; init; } = false;
    public bool? MfaEnabled { get; init; }
    public bool? Verified { get; init; }
    public string? Email { get; init; }
}